searchNodes=[{"doc":"Connecting to remote serversRealbook provides be default two connection APIs, one of which (:local) can be used to provision locally. The other (:ssh) can be used to provision a remote host. In order to use the SSH api, generally, you must have passwordless ssh keys installed in the remote server. This default can be overridden in the connect!/2 function by providing options that correspond to SSH.connect/2 options.","ref":"Realbook.html","title":"Realbook","type":"module"},{"doc":"initiates a connection, bound to this process, using the specified module. You may also use a shorthand for the connection.Examplesusing explicit namingRealbook.connect!(Realbook.Adapters.Local)using shorthand namesRealbook.connect!(:ssh, host: host_ip, user: &quot;admin&quot;)","ref":"Realbook.html#connect!/2","title":"Realbook.connect!/2","type":"function"},{"doc":"generates an Elixir module corresponding to a realbook script string or iodata; then evaluates the module, bound to this process.If you provide only the script without a file, then the module will be an anonymous realbook module.It is generally not recommended to use this function directly, but it may be useful for user debugging purposes or ad-hoc testing via the Elixir REPL.Only use this function if you know what you are doing.","ref":"Realbook.html#eval/3","title":"Realbook.eval/3","type":"function"},{"doc":"retrieves a value from the Realbook dictionary by its corresponding key.See set/1 for details on how the key/values are stored.","ref":"Realbook.html#get/2","title":"Realbook.get/2","type":"function"},{"doc":"loads a script from the suppiled path, compiles it into a Realbook module and executes it.If the module already exists, then the existing module will be run without recompilation.Warning:This does not currently check if the script has changed prior to deciding not to recompile, but that safety check may be revised in the future.","ref":"Realbook.html#run/1","title":"Realbook.run/1","type":"function"},{"doc":"puts keys into the Realbook dictionary.This is a key-value store which stores &quot;variables&quot; for your Realbook scripts. Note that these key/values are stored in an ets table under the Realbook caller's process pid.Typically, you will run set/1 prior to executing the Realbook script to satisfy all parameters that the it must have at runtime. The Realbook script performs a compile-time check to identify all necessary parameters and will refuse to run unless these parameters have been assigned.Note that a spawned task will not have access to the Realbook key/value store of its parent. This may change in the future.","ref":"Realbook.html#set/1","title":"Realbook.set/1","type":"function"},{"doc":"Compile and execute a realbook starting at this point in the code.This form doesn't perform any interpolation.This is the recommended entry point for realbooks, though you can also use run/1 to directly run a realbook file.Exampledefmodule MyRealbookEntryModule do # ... def run_realbooks do ~B&quot;&quot;&quot; requires ~w(realbook1 realbook2 realbook2) verify false play do # ... log &quot;running realbooks&quot; end &quot;&quot;&quot; end end","ref":"Realbook.html#sigil_B/2","title":"Realbook.sigil_B/2","type":"macro"},{"doc":"like sigil_B/2 but lets you interpolate values from the surrounding context.","ref":"Realbook.html#sigil_b/2","title":"Realbook.sigil_b/2","type":"macro"},{"doc":"common interface for communications adapters between the local machine and the remote deployment target.All realbook command macros adapt this interface to perform the relevant commands.For example code, see:Realbook.Adapters.LocalRealbook.Adapters.SSH","ref":"Realbook.Adapters.Api.html","title":"Realbook.Adapters.Api","type":"behaviour"},{"doc":"appends a binary or a file to the remote server.NB: options might take the :sudo options, which should be filtered prior to sending the contents.","ref":"Realbook.Adapters.Api.html#c:append/4","title":"Realbook.Adapters.Api.append/4","type":"callback"},{"doc":"connects into the remote target and produces a conn/0 token.NB: for Realbook.Adapters.SSH the host parameter will live in this variable.","ref":"Realbook.Adapters.Api.html#c:connect/1","title":"Realbook.Adapters.Api.connect/1","type":"callback"},{"doc":"executes a unix command on the remote target.Warning:this may or may not support piping operations, depending on the underlying implementation. The guidelines for running pipes may change in the future.","ref":"Realbook.Adapters.Api.html#c:run/3","title":"Realbook.Adapters.Api.run/3","type":"callback"},{"doc":"sends a binary or a file to the remote server.NB: options might take the :sudo options, which should be filtered prior to sending the contents.","ref":"Realbook.Adapters.Api.html#c:send/4","title":"Realbook.Adapters.Api.send/4","type":"callback"},{"doc":"A token that represents the remote deployment target.Such a token will be provided to the adapter functions as their first parameter. Produced by connect/1","ref":"Realbook.Adapters.Api.html#t:conn/0","title":"Realbook.Adapters.Api.conn/0","type":"type"},{"doc":"allows you to select a stored key for content or file name","ref":"Realbook.Adapters.Api.html#t:variable_key/0","title":"Realbook.Adapters.Api.variable_key/0","type":"type"},{"doc":"","ref":"Realbook.Adapters.Local.html","title":"Realbook.Adapters.Local","type":"module"},{"doc":"Callback implementation for Realbook.Adapters.Api.append/4.","ref":"Realbook.Adapters.Local.html#append/4","title":"Realbook.Adapters.Local.append/4","type":"function"},{"doc":"Callback implementation for Realbook.Adapters.Api.connect/1.","ref":"Realbook.Adapters.Local.html#connect/1","title":"Realbook.Adapters.Local.connect/1","type":"function"},{"doc":"Callback implementation for Realbook.Adapters.Api.run/3.","ref":"Realbook.Adapters.Local.html#run/3","title":"Realbook.Adapters.Local.run/3","type":"function"},{"doc":"Callback implementation for Realbook.Adapters.Api.send/4.","ref":"Realbook.Adapters.Local.html#send/4","title":"Realbook.Adapters.Local.send/4","type":"function"},{"doc":"","ref":"Realbook.Adapters.Local.html#sudo_append/2","title":"Realbook.Adapters.Local.sudo_append/2","type":"function"},{"doc":"Tips:you might need this option: silently_accept_hosts: true","ref":"Realbook.Adapters.SSH.html","title":"Realbook.Adapters.SSH","type":"module"},{"doc":"Callback implementation for Realbook.Adapters.Api.append/4.","ref":"Realbook.Adapters.SSH.html#append/4","title":"Realbook.Adapters.SSH.append/4","type":"function"},{"doc":"Callback implementation for Realbook.Adapters.Api.connect/1.","ref":"Realbook.Adapters.SSH.html#connect/1","title":"Realbook.Adapters.SSH.connect/1","type":"function"},{"doc":"Callback implementation for Realbook.Adapters.Api.run/3.","ref":"Realbook.Adapters.SSH.html#run/3","title":"Realbook.Adapters.SSH.run/3","type":"function"},{"doc":"Callback implementation for Realbook.Adapters.Api.send/4.","ref":"Realbook.Adapters.SSH.html#send/4","title":"Realbook.Adapters.SSH.send/4","type":"function"},{"doc":"","ref":"Realbook.Adapters.SSH.html#sudo_append/3","title":"Realbook.Adapters.SSH.sudo_append/3","type":"function"},{"doc":"","ref":"Realbook.Adapters.SSH.html#sudo_send/4","title":"Realbook.Adapters.SSH.sudo_send/4","type":"function"},{"doc":"Command macros that are helper functions for common tasks.imported into your Realbook scripts by default.","ref":"Realbook.Commands.html","title":"Realbook.Commands","type":"module"},{"doc":"appends binary content to the target file.returns ok if successful and raises on either a connection error or a sending error.","ref":"Realbook.Commands.html#append!/3","title":"Realbook.Commands.append!/3","type":"macro"},{"doc":"finds a file at the path (relative to the application env variable :realbook, :asset_dir), opens it, and returns the binary.raises if :asset_dir is not set or if there is a problem with the file.","ref":"Realbook.Commands.html#asset!/1","title":"Realbook.Commands.asset!/1","type":"macro"},{"doc":"extracts the specified keys out of the realbook dictionary and wraps them into a map. Useful for when an EEx template is generated from an assigns variable.","ref":"Realbook.Commands.html#assigns/1","title":"Realbook.Commands.assigns/1","type":"macro"},{"doc":"raises Realbook.ExecutionError automatically with the issued comment.","ref":"Realbook.Commands.html#fail/1","title":"Realbook.Commands.fail/1","type":"macro"},{"doc":"gets a value from the Realbook key/value store. Registers the key as required prior to running the script.","ref":"Realbook.Commands.html#get/1","title":"Realbook.Commands.get/1","type":"macro"},{"doc":"gets a value from the Realbook key/value store, providing a default value if the key has not been set yet.ImportantThis will not set the value if it has not been set yet.","ref":"Realbook.Commands.html#get/2","title":"Realbook.Commands.get/2","type":"function"},{"doc":"sends a log message with canonical realbook metadata and desired message.","ref":"Realbook.Commands.html#log/1","title":"Realbook.Commands.log/1","type":"macro"},{"doc":"runs a command on the remote host.For options, consult your adapter module.raises Realbook.ExecutionError if there is a connection error.if the command is executed, returns:{:ok, stdout} if the command has zero return code.{:error, error, retcode} if the command has nonzero return code.Notethe stdout term in run may have trailing spaces or carriage returns depending on the command being executed; run!/2 will trim this for you.","ref":"Realbook.Commands.html#run/2","title":"Realbook.Commands.run/2","type":"macro"},{"doc":"runs a command on the remote host.For options, consult your adapter module.raises Realbook.ExecutionError if there is a connection error OR if the executed command returns a nonzero return code.if the command returns a zero return code, this macro returns the standard output of the command.Noterun! peforms a String.trim/1 operation on the output, and run/2 does not.","ref":"Realbook.Commands.html#run!/2","title":"Realbook.Commands.run!/2","type":"macro"},{"doc":"sends binary content to the target.returns ok if successful and raises on either a connection error or a sending error.","ref":"Realbook.Commands.html#send!/3","title":"Realbook.Commands.send!/3","type":"macro"},{"doc":"sets key/value pairs into the Realbook key/value store. Registers the keys as provided by the script.","ref":"Realbook.Commands.html#set/1","title":"Realbook.Commands.set/1","type":"macro"},{"doc":"pauses for time milliseconds","ref":"Realbook.Commands.html#sleep/1","title":"Realbook.Commands.sleep/1","type":"macro"},{"doc":"like append!/3 but useful for files which are owned by superuser.","ref":"Realbook.Commands.html#sudo_append!/3","title":"Realbook.Commands.sudo_append!/3","type":"macro"},{"doc":"like run/2, except with the command run as superuser","ref":"Realbook.Commands.html#sudo_run/2","title":"Realbook.Commands.sudo_run/2","type":"macro"},{"doc":"like run!/2, except with the command run as superuser","ref":"Realbook.Commands.html#sudo_run!/2","title":"Realbook.Commands.sudo_run!/2","type":"macro"},{"doc":"like send/3 but changes posession of the file to superuser after transmission.","ref":"Realbook.Commands.html#sudo_send!/3","title":"Realbook.Commands.sudo_send!/3","type":"macro"},{"doc":"performs the remote command and repeats it if the command raises or returns false. Useful for events which may take action after the command is issued, such as systemctl actions.Options:count (integer) how many times we should try. Defaults to 10.:wait (integer) how many millseconds we should. Defaults to 1000.:callback an arity-1 lambda that will be passed the options map list each time the system fails. This map has the following fields::count how many times are left:wait how many milliseconds will be waited the next round:backoff exponential factor for the next wait, must be &gt; 1 the result of the callback should be updated options; you may also save metadata here, if desired; but do not delete the :count or :wait keys.:backoff (float)Examplewait_till count: 50 do run! &quot;systemctl is-active --quiet my_service&quot; endwait_till count: 10, do run! &quot;some-command&quot; end","ref":"Realbook.Commands.html#wait_till/2","title":"Realbook.Commands.wait_till/2","type":"macro"},{"doc":"Top-level macros that you will use to build out Realbook scripts.These are imported into your Realbook scripts by default.","ref":"Realbook.Macros.html","title":"Realbook.Macros","type":"module"},{"doc":"","ref":"Realbook.Macros.html#load_module_by_file/1","title":"Realbook.Macros.load_module_by_file/1","type":"function"},{"doc":"defines actions that perform the operations of a realbook scriptthis action is triggered if verify/1 fails. If any event in the play/1 raises, then the system will halt and throw Realbook.ExecutionError.","ref":"Realbook.Macros.html#play/1","title":"Realbook.Macros.play/1","type":"macro"},{"doc":"defines a list of realbook files which should be run prior to running this realbook file.UsageThis directive should be at the head of the realbook script.requires &quot;foo.exs&quot;or you may also submit a list of filesrequires ~w(foo.exs bar.exs baz.exs)warning:this doesn't currently perform cyclical dependency checks.","ref":"Realbook.Macros.html#requires/1","title":"Realbook.Macros.requires/1","type":"macro"},{"doc":"defines actions that assess the completion of a realbook script.These actions are performed twice. Once prior to execution, and once after execution. If the first verification stage fails, the play/1 stage is activated. If it succeeds, the play/1 stage is not activated.The verification is repeated after play/1. If it fails at this stage, the system will halt and throw Realbook.ExecutionError.Typically, the contents of the verification stage should not alter the remote target, but only perform analysis of the system.To cause the play/1 block to always execute, you may declare:verify falseGuidelinesVerification fails when one of two things happens:any internal directive raisesthe block returns falseGenerally speaking the verify/2 block should contain a sequence of validating run! directives which, if any fails causes a failure. If you are retrieving value(s) that need to be compared (for example shasums), drop those comparisons as the last test to trigger the final boolean value check.If you want to quit early on a boolean comparison value and avoid long-running or computationally expensive checks, you can use the following type of statement:unless &lt;comparison&gt;, do: fail! &quot;failure message&quot;","ref":"Realbook.Macros.html#verify/1","title":"Realbook.Macros.verify/1","type":"macro"},{"doc":"","ref":"Realbook.AssetError.html","title":"Realbook.AssetError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Realbook.AssetError.html#message/1","title":"Realbook.AssetError.message/1","type":"function"},{"doc":"","ref":"Realbook.ConnectionError.html","title":"Realbook.ConnectionError","type":"exception"},{"doc":"","ref":"Realbook.ExecutionError.html","title":"Realbook.ExecutionError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Realbook.ExecutionError.html#message/1","title":"Realbook.ExecutionError.message/1","type":"function"},{"doc":"Introduction to RealbookRealbook is a simple, imperative DSL that helps you provision and set up linux-based servers.If you have a linux based machine, you can use Realbook to make sure that the required software and soft assets are properly installed and configured on this machine. Because Realbook uses the BEAM under the hood, it is possible to provision multiple machines concurrently, which is a desirable feature for on-metal deployments.Realbook is also useful for other deployments (like VMs), since it can produce reproducible environments (potentially across time) via its self-validation scheme.","ref":"0-introduction.html","title":"Introduction to Realbook","type":"extras"},{"doc":"Amy wants to provision an Ubuntu 18.04 machine that will serve as a DHCP server. To do this, she creates some realbook scripts in her ~/realbook-scripts directory.install_dhcp.exsverify do # verifies that isc-dhcp-server software exists by checking # the existence of the software in the apt repository db run!(&quot;apt list isc-dhcp-server&quot;, tty: true, stdout: :stream) =~ &quot;installed&quot; end play do sudo_run! &quot;apt-get install isc-dhcp-server&quot; endconfigure_dhcp.exsrequires &quot;install_dhcp&quot; @dhcp_conf_path &quot;/etc/dhcp/dhcpd.conf&quot; # templates the /etc/dhcp/dhcpd.conf file to match the specifications # for isc-dhcp-server. A more advanced example would use EEx templates # to achieve this. def dhcpd_conf do &quot;&quot;&quot; default-lease-time 600; max-lease-time 7200; option subnet-mask 255.255.255.0; option broadcast-address \#{get :broadcast}; option routers \#{get :router}; # give the client either cloudflare or google DNS option domain-name-servers 1.1.1.1 8.8.8.8; option domain-name &quot;amysdomain.local&quot;; subnet \#{get :subnet} netmask 255.255.255.0 { range \#{get :range_start} \#{get :range_end}; } &quot;&quot;&quot; end verify do # checks that the system configuration matches the supplied # configuration by comparing sha256sum. By doing this we # can come back to the system later and use the same script # to overwrite the configuration settings if they should change. shasum = :sha256 |&gt; :crypto.hash(dhcpd_conf()) |&gt; Base.encode16(case: :lower) run!(&quot;sha256sum \#{@dhcp_conf_path}&quot;) =~ shasum end play do sudo_run! &quot;rm -rf \#{@dhcp_conf_path}&quot; sudo_send! dhcpd_conf(), @dhcp_conf_path endenable_dhcp.exsrequires &quot;configure_dhcp&quot; verify do # try, five times, over 5 seconds, to see if the dhcp server # is active. This is necessary because the systemctl command # performs some things asynchronously. wait_till count: 5 do run! &quot;systemctl is-enabled --quiet isc-dhcp-server&quot; end end play do sudo_run! &quot;systemctl enable isc-dhcp-server&quot; endreset_dhcp.exsrequires &quot;reset_dhcp&quot; # always reset the dhcp server (this is for the case when we didn&#39;t # have to enable the dhcp server) verify false play do sudo_run! &quot;systemctl restart isc-dhcp-server&quot; endRunning the realbooksHaving defined the realbooks, Amy now needs to execute them on her remote server. In this example, she will simply use the iex shell to achieve this.iex&gt; Application.put_env(:realbook, :script_dir, &quot;~/realbook-scripts&quot;) iex&gt; Realbook.connect!(:ssh, host: &quot;amys.host.ip&quot;, user: &quot;admin&quot;, identity: &quot;~/my_key.pem&quot;) iex&gt; Realbook.set( broadcast: &quot;192.168.1.255&quot;, router: &quot;192.168.1.1&quot;, subnet: &quot;192.168.1.0&quot;, range_start: &quot;192.168.1.10&quot;, range_end: &quot;192.168.1.64&quot;) iex&gt; import Realbook iex&gt; ~B&quot;requires ~w(install_dhcp configure_dhcp enable_dhcp reset_dhcp)&quot;If Amy had forgotten any of the required variables, then the script would not run. If Amy would like to change the settings later, this particular script's strategy lets her simply input different settings in the Realbook.set command and it will redo the dhcp configuration.","ref":"0-introduction.html#example","title":"Introduction to Realbook - Example","type":"extras"},{"doc":"Realbook BasicsA Realbook is a fundamentally a shorthand way of specifying an Elixir Module. Anything you could write inside a Kernel.defmodule/2 clause you can write inside of a realbook, and in fact your realbook script will wrapped inside of a defmodule statement.A realbook (or set of realbooks) executes linearly in a single BEAM process.","ref":"1-basics.html","title":"Realbook Basics","type":"extras"},{"doc":"The realbook script itself should be considered a unit of declarative provisioning. In order to bridge imperative code and declarative Realbook provides three pre-imported macros:Realbook.Macros.requires/1 (optional) lets you declare a list of other realbook scripts which must be run prior to the current one to guarantee successful execution.Realbook.Macros.verify/1 (required) specifies instructions which are run prior to execution; if verify passes, the Realbook.Macros.play/1 contents will not be executed. After executing the play contents, verify will be rerun to assess the overall success of the provision.Realbook.Macros.play/1 (required) specifies instructions to actually be run.","ref":"1-basics.html#bridging-the-imperative-with-declarative","title":"Realbook Basics - Bridging the imperative with declarative","type":"extras"},{"doc":"Realbook scripts provide way of sharing configuration variables between scripts. It may also be the case that a script could optionally define a variable to be used by a downstream script. Two pre-imported macros help you share configuration variables:Realbook.Commands.get/1 lets you retrieve a configuration variable using an atom key.Realbook.Commands.set/1 lets you set a configuration variable from within a script.Realbook modules perform code analysis at compile time, and remember which configuration variables must be set prior to running. If a necessary configuration variable has not been set, then the script will not enter the first verify, and will raise with an error warning that the variable hasn't been set.To set a variable prior to executing the module, use the Realbook.set/1 function.Note that Realbook variables are threadsafe, they aren't shared between concurrently running Realbook processes. That also means that you must set them on a process-by-process basis.","ref":"1-basics.html#checking-variable-existence-prior-to-running","title":"Realbook Basics - Checking variable existence prior to running.","type":"extras"},{"doc":"A process running a realbook script is associated with a provisioning conn. This is a connection value representing the communication between the provisioning host (that is running realbook) and the provisioning target. Use Realbook.connect!/1 (typically outside of the realbook script). See running a realbook.Once you are in, the following pre-imported commands can be used to perform imperative functions on the target (these should typically be in either the verify or the ):To run commands directly, use:Realbook.Commands.run/1Realbook.Commands.run!/1Or if you need to be superuser:Realbook.Commands.sudo_run/1Realbook.Commands.sudo_run!/1Note that the bang! versions of the functions will raise if a non-zero return code (failure) is emitted by the program. If you are expecting a non-zero code or need to take decisions based on more detailed information, use the non-bang versions, which will return {:ok, stdout} or {:error, stderr, return_code}. The non-bang functions will still raise if there's a connection error between the host and the target.To send files to the target, use:Realbook.Commands.send!/2 andRealbook.Commands.sudo_send!/2 if you need to be superuser.To append to files on the target, use:Realbook.Commands.append!/2 andRealbook.Commands.sudo_append!/2 if you need to be superuser.","ref":"1-basics.html#provisioning-connections-and-commands","title":"Realbook Basics - Provisioning connections and commands","type":"extras"},{"doc":"Writing a Realbook","ref":"2-writing_a_realbook.html","title":"Writing a Realbook","type":"extras"},{"doc":"To describe how to write a realbook let's use a real example:verify do (run! &quot;hostname&quot;) == (get :hostname) end play do hostname = get :hostname sudo_run! &quot;hostnamectl set-hostname \#{hostname}&quot; endThis simple example is used to set the hostname on an ubuntu system and embodies several key points.Prior to running the realbook script, a :hostname variable has to be set (not included in this code)according to the verify clause, the hostname variable should match what we expect to be the remote hostname to be, via the hostname command.if it doesn't match (which it won't if it's the first initialization), then we should reset the hostname using the hostnamectl command which must be superuser to be run.Verification strategiesverify blocks fail if either there is a raiseing event inside the block or if the block returns a falsy value (nil or false). Here are some tips for concise and legible verifications:use raiseing clauses aggressively and early in your verificationwait for boolean checks (for example, comparing checksum values)if you must raise early on a boolean, use the following strategy featuring the Realbook.Commands.fail/1 macro:defp matches_checksum?(value), do: value == @checksum verify do # some code here matches_checksum?(thing_to_check) or fail(&quot;checksum failed!&quot;) # more code end","ref":"2-writing_a_realbook.html#a-basic-example","title":"Writing a Realbook - A basic example","type":"extras"},{"doc":"Typically, installers expect the running system to be a tty system. This is the case, for example for ubuntu systems using the apt package manager.The following example shows using module attributes as constants, as well as well as using run!/2 and sudo_run!/2 with the tty option.@items ~w(apparmor fail2ban) verify do Enum.all?(@items, fn item -&gt; # note that we should redirect stdout to the main stdout stream in # order be able to verify that it&#39;s installed. run!(&quot;apt list \#{item}&quot;, tty: true, stdout: :stream) =~ &quot;installed&quot; end) end play do # note this will forward the apt status reports to the local console. sudo_run! (&quot;apt-get -y install &quot; &lt;&gt; Enum.join(@items, &quot;\\s&quot;)), tty: true end","ref":"2-writing_a_realbook.html#software-installers","title":"Writing a Realbook - Software Installers","type":"extras"},{"doc":"You may load binary assets in an assets directory using Realbook.Commands.asset!/1 macro. Application.get_env(:realbook, :assets_dir) must be set, and the file must exist, or the realbook will fail to trigger.","ref":"2-writing_a_realbook.html#assets","title":"Writing a Realbook - Assets","type":"extras"},{"doc":"If you want to unconditionally execute a play block, use the verify false directive. Note that such a script will not perform a postverification, so if you must perform some verification of your results, you should leave those at the tail of your play block.","ref":"2-writing_a_realbook.html#unconditional-execution","title":"Writing a Realbook - Unconditional execution","type":"extras"},{"doc":"It's possible to write a realbook which is the chained composition of several realbooks, the following is a trivial realbook which only serves to execute a series of other scripts:requires ~w(my_script_1 my_script_2 my_script_3)You're allowed to omit Realbook.Macros.play/1 and Realbook.Macros.verify/1 directives if you have a Realbook.Macros.requires/1 statement.If you want to use this as a sole entry point for a series of realbooks, you should consider using Realbook.sigil_B/2.","ref":"2-writing_a_realbook.html#multi-realbooks","title":"Writing a Realbook - Multi-Realbooks","type":"extras"},{"doc":"Two more commands are automatically imported:Realbook.Commands.sleep/1 which sleeps the realbook process.Realbook.Commands.log/1 which creates a log event. Currently this does not provide extra log metadata, but will do so in the future.","ref":"2-writing_a_realbook.html#other-goodies","title":"Writing a Realbook - Other goodies","type":"extras"},{"doc":"Running a realbookIn order to run a realbook, you must do four things. It's probably a good idea to wrap all of these steps in a single Task, and place that task in a supervision tree.","ref":"3-running_a_realbook.html","title":"Running a realbook","type":"extras"},{"doc":"Specify the realbook directory. This is global, and can be set at compile time using the Config.config/2 directive in your config.exs or child configuration files.Application.put_env(:realbook, :script_dir, realbook_script_dir)If you're going to release your app to prod, it's recommended to keep these scripts in the priv directory.Connect to the target. The following example shows how to connect with passwordless ssh. For other options, see SSH.connect/2:Realbook.connect!(:ssh, host: &quot;my_host&quot;, user: &quot;admin&quot;)Note that the :local connect target is also provided.Set required variables. If you forget any, the realbook won't execute.Realbook.set(foo: &quot;bar&quot;, baz: &quot;quux&quot;) Launch the realbook.Realbook.run(&quot;my_realbook_script.exs&quot;)","ref":"3-running_a_realbook.html#external-mode","title":"Running a realbook - External mode","type":"extras"},{"doc":"Steps 1-3 are the same as above.Instead of launching the realbook by file, use Realbook.sigil_B/2 to run an inline realbook.def run_realbook do ~B&quot;&quot;&quot; verify false play do # my code end &quot;&quot;&quot; endThis is especially useful if you are using requires to batch groups of realbooks.def run_realbook do ~B&quot;&quot;&quot; requires [&quot;my_realbook1&quot;, &quot;my_realbook2&quot;, &quot;my_realbook3&quot;] &quot;&quot;&quot; end","ref":"3-running_a_realbook.html#inline-mode","title":"Running a realbook - Inline mode","type":"extras"},{"doc":"Deployment","ref":"4-deployment.html","title":"Deployment","type":"extras"},{"doc":"It's recommended to create an escript or mix task to perform the Realbook operations. Guidelines for this process will be forthcoming.","ref":"4-deployment.html#using-without-releases","title":"Deployment - Using without Releases","type":"extras"},{"doc":"With scripts in a generic location.Create an entrypoint function (e.g. MyApp.go/1). Let's say this function takes the :script_dir as a parameter and sets that application, then launches the script(s)Upload your scripts (and assets) to your provisioning server (for example ~/my_scripts)Perform a release and transfer your application to the provisioning server.Execute the realbooks.&gt; path/to/release/my_app eval 'MyApp.go &quot;~/my_scripts&quot;'With scripts and assets in the priv/ directorystore your scripts and assets in, for example priv/scripts and priv/assetscreate an entrypoint function that sets :script_dir as follows:script_dir = :my_app |&gt; :code.priv_dir |&gt; Path.join(&quot;scripts&quot;) Application.put_env(:realbook, :script_dir, script_dir)repeat with :assets_dirPerform a release and transfer the application to the provisioning server.Execute the realbooks.&gt; path/to/release/my_app eval 'MyApp.go'The advantage to the latter method is that it allows you to package your scripts with your deployment. If for some reason you want to keep them separate, (for example, if they are shared in a repo between multiple projects) then you should use the former method.","ref":"4-deployment.html#deployment-using-mix-releases","title":"Deployment - Deployment using Mix Releases","type":"extras"},{"doc":"Testing RealbooksComing soon.","ref":"5-testing.html","title":"Testing Realbooks","type":"extras"}]